<template>
  <PageContainer>
    <template slot="header">
      <MControlPanel
        :state="pageState"
        :can-create="canCreate"
        :can-update="canUpdate"
        @on-state-button-clicked="onStateButtonClicked()"
        @on-action-button-clicked="onActionButtonClicked()"
        :actions="actions"
      >
      </MControlPanel>
    </template>

    <template slot="content" style="background-color: white">
      <div class="row justify-left" style="background-color: white; ">
        <div class="col-12 q-pb-xs q-pt-xs q-pl-md  q-mt-xs q-mb-xs">
          <ValidationObserver v-slot="{ handleSubmit }">
            <q-form ref="FormSubmit" @submit="handleSubmit(onSubmit)">
              <q-card bordered flat square class="row q-pa-md q-ma-sm scroll">
                <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                  <MField
                    v-model="form.code"
                    :hide-bottom-space="pageState ==='view' "
                    :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                    :readonly="pageState ==='view' "
                    label="Code"
                    orientation="vertical"
                    validation-rules="required"
                    @m-keyup-enter="onFormSubmit"
                  />
                </div>
                <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                  <MField
                    v-model="form.description"
                    :hide-bottom-space="pageState === 'view' "
                    :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                    :readonly="pageState === 'view' "
                    error-message="Champ requis."
                    label="Description"
                    orientation="vertical"
                    validation-rules="required"
                    @m-keyup-enter="onFormSubmit"/>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 q-mt-lg">
                  <strong class="q-pb-none float-left">Valeur du paramètre</strong>
                  <q-toggle :disable="pageState === 'view'"
                            class="float-right"
                            v-model="isKeyValue"
                            label="Clé/Valeur"
                  />
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" v-if="!isKeyValue">
                  <MField
                    v-model="form.value"
                    :hide-bottom-space="pageState === 'view' "
                    :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                    :readonly="pageState === 'view' "
                    error-message="Champ requis."
                    label=" "
                    hint="S'il s'agit d'une chaîne de caractères, vous devez l'entourer de guillemets."
                    orientation="vertical"
                    validation-rules="required"
                    @m-keyup-enter="onFormSubmit"/>
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" v-else>
                  <q-table
                    dense flat
                    :data="configValues"
                    :columns="columns"
                    row-key="key"
                  >
                    <q-tr slot="header" slot-scope="props" :props="props">
                      <q-th class="text-bold" style="font-weight: bold" v-for="(col) in props.cols" :key="col.name"
                            :props="props">
                        {{ col.label }}
                      </q-th>
                      <q-th auto-width>
                      </q-th>
                    </q-tr>

                    <template slot="body" slot-scope="props">
                      <q-tr :props="props" auto-height class="cursor-pointer wrap">
                        <q-td v-for="(col) in props.cols" :key="col.name">
                          <q-input v-model="props.row[col.name]" dense autogrow borderless
                                   :readonly="pageState === 'view'"/>
                        </q-td>
                        <q-td auto-width v-if="pageState !== 'view'">
                          <q-btn
                            ref="btn" flat round icon="la la-trash-alt" text-color="red" stretch size="11px"
                            @click.stop="onDeleteRow(props.row)">
                            <q-tooltip>Supprimer</q-tooltip>
                          </q-btn>
                        </q-td>
                      </q-tr>
                    </template>
                    <template v-slot:bottom-row="cols" v-if="pageState !== 'view'">
                      <q-tr class="cursor-pointer">
                        <q-td colspan="100%" class="text-left ">
                          <a @click.prevent="onAddRow" class="text-primary">Ajouter</a>
                        </q-td>
                      </q-tr>
                    </template>
                    <template v-slot:bottom="cols"></template>
                  </q-table>
                </div>
              </q-card>
            </q-form>
          </ValidationObserver>
        </div>
      </div>
    </template>
  </PageContainer>
</template>

<script>
import PageContainer from "components/PageContainer";
import MControlPanel from "components/MControlPanel";
import {mapActions, mapState} from 'vuex'
import MField from "components/forms/MField";
import MSelect from "components/forms/MSelect";
import MTable from "components/datatables/MTable";
import {ValidationObserver} from 'vee-validate';
import get from "lodash/get";

export default {
  name: "ParametersForm",
  components: {PageContainer, MControlPanel, MField, MSelect, MTable, ValidationObserver},

  async preFetch({store, currentRoute}) {
    let id = currentRoute.query.id || currentRoute.params.id
    if (id) return await store.dispatch('parameters/show', {id});
  },

  data() {
    return {
      isKeyValue: false,
      loading: false,
      form: {},
      configValues: [],
      columns: [
        {name: 'key', align: 'left', label: 'Clé', field: 'key'},
        {name: 'value', align: 'left', label: 'Valeur', field: 'value'},
      ],
    }
  },

  methods: {
    onSubmit() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment effectuer cette action ?',
        cancel: true,
        persistent: false,
      }).onOk(() => {
        let payload = this.getPayload()
        this.Loader.show()
        let promise = payload.id ? this.update(payload) : this.create(payload);
        let msg = payload.id ? 'Mise à jour!' : 'Création réussie';
        promise.then(async res => {
          await this.$store.dispatch('parameters/show', {id: res.id}).then(async () => {
            await this.Motify('success', msg, {path: `${this.baseUrl}/form/view`, query: {id: res.id}})
            this.form = _.clone(this.currentItem)
          }).catch((err) => {
            this.Motify('error', this._getErrorMessage(err))
          })
        }).catch(err => {
          console.error(err);
          this.Motify('error', this._getErrorMessage(err), null, 5000)
        }).finally(() => {
          this.Loader.hide()
        })
      })
    },

    mapPayload() {
      if (this.pageState === 'create') {
        this.resetForm()
      } else if (this.pageState === 'update' || this.pageState === 'view') {
        if (this.currentItem) {

          this.form = {
            ..._.clone(this.mForm),
            ...this.currentItem,
          }
          let values = get(this.currentItem, 'value', '')
          if (typeof values === 'string') {
            this.form.value = `"${values}"`
          } else if (typeof values === 'object') {
            this.configValues = []
            values = Object.entries(values).map(([key, value]) => ({key, value}))
            this.configValues.push(...values)
            this.isKeyValue = true
            this.form.value = null
          }
        }
      }
    },

    getPayload() {
      let data = {
        ...this.form,
      }

      if (this.isKeyValue) {
        let value = {}
        this.configValues.forEach(x => {
          if (x.key)
            value[x.key] = x.value
        })
        data.value = value
      }
      return data
    },

    resetForm() {
      this.form = _.clone(this.mForm)
    },

    onDeleteRow(row) {
      if (row)
        this.configValues = this.configValues.filter(x => x.key !== row.key)
    },
    onAddRow() {
      this.configValues.push({key: '', value: ''})
    },

    onDuplicate() {
      this.$q.dialog({
        parent: this,
        message: 'Voulez-vous vraiment dupliquer cet enregistrement?',
        cancel: true,
      }).onOk(() => {
        this.form = _.clone(this.currentItem)
        this.form.id = null
        return this.$router.replace({path: `${this.baseUrl}/form/create`})
      })
    },

    onFormSubmit() {
      !this.$refs.FormSubmit.submit()
    },

    onStateButtonClicked() {
      if (this.pageState === 'view') {
        return this.$router.replace({
          path: `${this.baseUrl}/form/update`,
          query: {id: this.$route.query.id},
        })
      } else {
        this.onFormSubmit()
      }
    },

    onActionButtonClicked() {
      if (this.pageState === 'update') {
        this.$router.push({
          path: `${this.baseUrl}/form/view`,
          query: {id: this.$route.query.id},
        })
      } else if (this.pageState === 'create') {
        this.$router.push({path: `${this.baseUrl}`,})
      } else if (this.pageState === 'view') {
        this.resetForm()
        this.$router.push({
          path: `${this.baseUrl}/form/create`,
        })
      }
    },

    async preFetchList() {
    },

    ...mapActions({
      create: 'parameters/create',
      update: 'parameters/update',
    }),
  },

  computed: {
    pageState() {
      return this.$route.params.type || this.$route.query.type
    },
    canCreate() {
      return true
    },
    canUpdate() {
      return true
    },
    actions() {
      return [
        {
          label: 'Dupliquer',
          func: this.onDuplicate,
          display: (this.pageState !== 'create' && this.form)
        },
      ]
    },

    ...mapState({
      currentItem: state => state.parameters.item,
      baseUrl: state => state.parameters.baseUrl,
      mForm: state => state.parameters.form,
    })
  },

  async mounted() {
    this.mapPayload()
    await this.preFetchList()
  },
}
</script>

<style scoped>

</style>
